
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

public class BallGenPanel extends JPanel {

	public Image ballImage;
	double scale = 1;

	public Graphics g;
	public BallLinked balls;
	Options optionPanel;
	
	private boolean toggle = false;
	private boolean randomVelocity = false;

	private WillPangBallGen frame;
	public Ball currentBall;
	
//	private boolean mousePressed = false;
	
	int x = 0;
	int y = 0;
	int size = 4;
	
	
	public BallGenPanel (WillPangBallGen frame, double parsedScale, Options options) {
		this.frame = frame;
		scale = parsedScale;
		scale = 1;
		optionPanel = options;

		currentBall = new Ball (0,0,4,0,-1, 0, frame);
		
		
		balls = new BallLinked(this);
		Thread newThread = new Thread(balls);
		newThread.start();
	
		this.ballImage = frame.ballImage;
		g = getGraphics();
	
		addMouseMotionListener(new MouseMotionAdapter() {
			public void mouseMoved(MouseEvent evt) {
				
				// Update the current mouse coordinates
				x = evt.getX();
				y = evt.getY();
				updateCurrent();
			}
		});
	
		frame.addKeyListener(new KeyAdapter( ) {
			public void keyPressed (KeyEvent e) {
			
				keyPressedEvent(e);
			}
		});
		
		addMouseListener(new MouseAdapter() {
			public void mouseExited (MouseEvent evt) {
				currentBall = null;
			}
			public void mouseEntered (MouseEvent evt) {
				moveM();
			}
			public void mousePressed (MouseEvent evt) {
				mousePress();
			}
		});
		
	
		
	
	}
	public void moveM () {
		size = optionPanel.getBallSize();
		currentBall = new Ball (x,y,size,0,-1, optionPanel.getType(), frame);
	}
	
	public void updateCurrent () {
		try {
			currentBall.x = x;
			currentBall.y = y;
			currentBall.type = frame.types[optionPanel.getType()];
		} catch (Exception e) {
			//ignore
		}
		
	}
	
	public void mousePress () {
		
		if (randomVelocity) {
			optionPanel.setInitialVelocity( (int) ((optionPanel.getRan2()-optionPanel.getRan1()) * Math.random() + optionPanel.getRan1()));	
		}

		// Add a new ball
		balls.addBall(new Ball(x, y, optionPanel.getBallSize(), optionPanel.getInitialVelocity(), optionPanel.getHorDirection(), optionPanel.getType(), frame));
		 
		// Toggle the direction of the balls
		if (toggle) {
			if (optionPanel.getHorDirection() == 1) {
				optionPanel.setHorDirection(-1);
			} else {
				optionPanel.setHorDirection(1);					
			}
			
		
		}
	}
	
	public void keyPressedEvent (KeyEvent e) {
		int keyCode = e.getKeyCode(); //exctracts the keycode from the KeyEvent
	//		characters[0] = 0;
		int stepRate = optionPanel.getStepRate();
		
		switch (keyCode) {
			case KeyEvent.VK_C:
				balls.resetList();
			break;					
			case KeyEvent.VK_1:
				size = 1;
			break;			
			case KeyEvent.VK_2:
				size = 2;
			break;			
			case KeyEvent.VK_3:
				size = 3;
			break;			
			case KeyEvent.VK_4:
				size = 4;
			break;
			case KeyEvent.VK_5:
				size = 5;
			break;			
			case KeyEvent.VK_6:
				size = 6;
			break;			
			case KeyEvent.VK_7:
				size = 7;
			break;			
			case KeyEvent.VK_8:
				size = 8;
			break;
			case KeyEvent.VK_9:
				size = 9;
			break;
			case KeyEvent.VK_UP:
				y = y - stepRate;
				updateCurrent();
			break;
			case KeyEvent.VK_DOWN:
				y = y + stepRate;
				updateCurrent();				
			break;
			case KeyEvent.VK_LEFT:
				x = x - stepRate;
				updateCurrent();				
			break;
			case KeyEvent.VK_RIGHT:
				x = x + stepRate;
				updateCurrent();				
			break;
			case KeyEvent.VK_ENTER:
				mousePress();
				updateCurrent();				
			break;
			case KeyEvent.VK_SPACE:
				mousePress();
				updateCurrent();				
			break;								
			case KeyEvent.VK_F5:
				frame.willTankPanel.showDialog();
			break;
			case KeyEvent.VK_A:
				optionPanel.setHorDirection(1);
			break;
			case KeyEvent.VK_Z:
				optionPanel.setHorDirection(-1);
			break;
			case KeyEvent.VK_T:
				toggle = !toggle;
			break;
			case KeyEvent.VK_R:
				randomVelocity = !randomVelocity;
			break;
			case KeyEvent.VK_BACK_SPACE:
				balls.removeLast();
			break;
		}

		currentBall.ballSize = size;
		optionPanel.setSize(size);
	}
	
	public double getScale () {
		return scale;
	}
		
		
	public void paintComponent (Graphics g) {
		this.g = g;
		String message = "";
		if (toggle) {
			message = "Toggle Direction  ";
		}
		if (randomVelocity) {
			message = message + "Random Velocity ";
		}
		g.drawString(message, 0, 10);
		
	}


}