import java.util.LinkedList.*;
import java.util.*;

public class BallLinked implements Runnable {
	
	
	public LinkedList ballLinkedList = new LinkedList();
	private double scale;
	
	private BallGenPanel imagePane;
	
	public Ball currentBall;
	
	public BallLinked (BallGenPanel imagePane) {
		this.imagePane = imagePane;
		
		scale = imagePane.getScale();

		currentBall = imagePane.currentBall;
		
	}
	
	public void resetList () {
		ballLinkedList = new LinkedList();
	}
	
	
	public void addBall (Ball toAdd) {
		synchronized (ballLinkedList) {
			ballLinkedList.add(toAdd);
		}
	}
	

	

	public void run () {

		while (true) {
				drawAll();
				Delegate.doze(100);
			
		}
	}
	
	

	public void removeLast () {
		removeIndex(ballLinkedList.size() - 1);
	}
	
	public void removeIndex (int index) {
	
		LinkedList newList = new LinkedList();
		for (int i = 0; i < ballLinkedList.size(); i++) {
			if (i != index) newList.add(ballLinkedList.get(i));
		}
		
		ballLinkedList = newList;
		
		drawAll ();
	}
	
	
	public void drawAll () {
		
		currentBall = imagePane.currentBall;
		
		
		//Clear the panel
		try {
		imagePane.g.clearRect(0,0,imagePane.getWidth(), imagePane.getHeight());
		} catch (Exception e) {
		}
		
		//Go though all of the balls, drawing
		for (int i = 0; i<ballLinkedList.size(); i++) {
			Ball ball = (Ball) ballLinkedList.get(i);
			ball.draw();
		}

		try {
			currentBall.draw();
		} catch (Exception e) {
		}

		//repaint the panel
		imagePane.repaint();
	}
	
	/**
	 * Print all of the balls, in WillPang format.
	 */
	public String toString() {
		String current = "";
		for (int i = 0; i<ballLinkedList.size(); i++) {
			current = current + ballLinkedList.get(i).toString();
			if (i != ballLinkedList.size() -1) {
				current = current + "\n";
			}
		}
		return current;
	}
	
}
	
